function [Hy, dH]=one_entropy_gappr(s,nbins,gaus_std,penpar)
%gaus_std   - std of Gaussian
%penpar - penalty for (std(s)-1)^2
%added also constraint inside and multi signal calculation

sigma=gaus_std^2;
T=length(s);
s_min=min( -5 , min(s') );
s_max=max( 5 , max(s'));
dbins=(s_max-s_min)/nbins;
Hy=0; dH=zeros(1,T); 

dpsi=zeros(1,T); 
F=zeros(1,T);  dF=zeros(1,T);
Pdf=zeros(1,nbins); 
dpsi_binned=zeros(1,nbins); 
dz=zeros(1,T); dPdf_g=zeros(1,nbins);
dPdf=zeros(1,nbins); Ind_A=zeros(1,T);
for n=1:T
  ind_a=floor((s(n)-s_min)/dbins); %indexes between 1 to nbins-1
  ind_a=max(1,min(ind_a,nbins-1));      
  k=((s(n)-s_min)/dbins)-ind_a;
  ind_b=ind_a+1;
  Ind_A(n)=ind_a;
  a=1-k;	dF(n)=-1/dbins;    
  b=1-a;
  F(n)=a; 
  Pdf(ind_a)=Pdf(ind_a)+ a;
  Pdf(ind_b)=Pdf(ind_b)+ b;  
end

tmax=8*sqrt(sigma); t=[dbins/2:dbins:tmax]; Lt=length(t); t= [-fliplr(t) t(2:end)]; 
G=exp(-t.^2/2/sigma); ccc = sum(G)*dbins*T ; G=G/ccc;
Gmax=max(G); G0=G(Lt); Gm1=G(Lt-1); Gp1=G(Lt+1);
dG=-(1/sigma).*t.*G;
%figure;plot([G;dG]');keyboard
Lg=length(G);
temp=convfft(Pdf,G);
Pdf_g=temp((Lg+1)/2:(Lg+1)/2+nbins-1)';
%figure;plot([Pdf_g(:) Pdf_g2(:)]);keyboard
temp=convfft(Pdf,dG);
Pdf_g_tag=temp((Lg+1)/2:(Lg+1)/2+nbins-1)';
%figure,plot([Pdf(:) Pdf_g(:) Pdf_g_tag(:)])

for n=1:T
  ind_a=Ind_A(n); 
  ind_b=ind_a+1;
  a=F(n); b=1-a;
  p=(a*Pdf_g(ind_a)+ b*Pdf_g(ind_b) );
  Hy=Hy-log(p)/T;
  dpsi(n)=-1/p/T;
  dpsi_binned(ind_a)= dpsi_binned(ind_a)+ a*dpsi(n);
  dpsi_binned(ind_b)= dpsi_binned(ind_b)+ b*dpsi(n);
  dp=(a*Pdf_g_tag(ind_a)+ b*Pdf_g_tag(ind_b) ); %for first term 
  dH(n)=dH(n)+dp*dpsi(n); %first term
end 
stds=norm(s)/sqrt(T);
Hy=Hy+penpar*(stds-1)^2;
temp=convfft(dpsi_binned,dG);
dH_binned=temp((Lg+1)/2:(Lg+1)/2+nbins-1)';

dH=dH+F.*dH_binned(Ind_A)+ (1-F).*dH_binned(Ind_A+1)+...
    penpar*(2-2/stds)*s/T; 
dH=dH(:);